## boot-floppies 3.0.23

=== Makefile ===
# Top-level Makefile for boot-floppies
#   see README* for information

# @@ Marcel FIXME: resc*.bin target for i386 make both resc*.bin and root*.bin:
#                  update scripts and clean make rules

all::	build

# Configurable variables reside in the config file.
# Note: see README for notes on how to build boot-floppies for just one language.
include config

# common variables
include make/vars

# architecture-specific variables
-include make/$(architecture).vars

# documentation rules live in documentation/Makefile*
include documentation/Makefile.docs

# i18n stuff -- must come after arch stuff
include make/i18n

# shell needs to be set to base for the release target, at least
SHELL = bash

# [ED] avoid direct compilation of C programs from the utilities subdir
# (see the root.bin dependencies).  BTW utils target does the right job.
.SUFFIXES:

null:
	: Null target for testing Makefile with "make -p null"

#---------------------------------------------------------------------------

localfiles:: updates
	set -e; \
	if [ -d $(incoming) ]; then \
	    cd $(incoming) ;\
	    find . -name '*_all.deb' -exec cp {} $(CURDIR)/updates/ \; ;\
	    find . -name '*_$(architecture).deb' -exec cp {} $(CURDIR)/updates/ \; ;\
	fi
	set -e; \
	if [ -d $(local_dir) ]; then \
	    cd $(local_dir) ;\
	    find . -name '*.deb' -exec cp {} $(CURDIR)/updates/ \; ;\
	fi
#	 it is better for the apt-get archives to be owned by user, not root
	[ -d $(archive) ] || mkdir -p $(archive)
	[ -d $(tmpdir)/boot-floppies ] || mkdir -p $(tmpdir)/boot-floppies

# dependency for the files that have to be copied
updates::
	[ -d updates ] || mkdir -p updates

build::	localfiles
	$(MAKE) utils
ifeq ($(architecture), i386)
	i18n_low_space=true make resc1200.bin resc1200-s.bin
	$(MAKE) resc1440.bin resc1440-s.bin
	$(MAKE) resc1440compact.bin
	$(MAKE) resc1440idepci.bin
	$(MAKE) resc1440bf2.4.bin
	$(MAKE) drivers.tgz
	$(MAKE) driverscompact.tgz
	$(MAKE) driversidepci.tgz
	$(MAKE) driversbf2.4.tgz
	$(MAKE) resc2880.bin
	$(MAKE) resc2880compact.bin
	$(MAKE) resc2880idepci.bin
	$(MAKE) resc2880bf2.4.bin
	$(MAKE) tftpboot.img
	$(MAKE) tftpboot-compact.img
	$(MAKE) tftpboot-idepci.img
	$(MAKE) tftpboot-bf2.4.img
else 
ifeq ($(architecture), m68k)
	$(MAKE) resc1440atari.bin driversatari.tgz
	$(MAKE) resc1440amiga.bin driversamiga.tgz
	$(MAKE) resc1440mac.bin driversmac.tgz
	$(MAKE) resc2880bvme6000.bin resc1440bvme6000.bin driversbvme6000.tgz
	$(MAKE) resc1440mvme16x.bin driversmvme16x.tgz
	$(MAKE) resc1440mvme147.bin driversmvme147.tgz
else 
ifeq ($(architecture), powerpc)
	$(MAKE) resc1440apus.bin driversapus.tgz
	$(MAKE) resc1440chrp.bin driverschrp.tgz
#	$(MAKE) resc1440mbx.bin driversmbx.tgz
	$(MAKE) resc1440pmac.bin driverspmac.tgz
	$(MAKE) resc2880newpmac.bin driversnewpmac.tgz
	$(MAKE) resc1440prep.bin driversprep.tgz bootprep.bin
#-----------------------------------------------------
#	$(MAKE) tftpboot-apus.img root.tar.gz
#	$(MAKE) tftpboot-chrp.img root.tar.gz
#	$(MAKE) tftpboot-mbx.img root.tar.gz
#	$(MAKE) tftpboot-pmac.img root.tar.gz
#	$(MAKE) tftpboot-prep.img root.tar.gz
else
ifeq ($(architecture), sparc)
	$(MAKE) resc1440sun4cdm.bin resc1440sun4u.bin
	$(MAKE) driverssun4cdm.tgz driverssun4u.tgz
	$(MAKE) tftpboot root.tar.gz
else
ifeq ($(architecture), alpha)
	mkdir -p $(alpha_milo_dir)
	for f in alcor xl book1 avanti cabriolet			\
		eb164 eb64p eb66 eb66p lx164 miata mikasa noname	\
		p2k sx164 takara; do					\
	    [ -f $(alpha_milo_dir)/milo-$(milo_version)-$$f ]		\
		|| (cd $(alpha_milo_dir)				\
			&& wget $(milo_url)/milo-$(milo_version)-$$f )  \
		|| exit 1;						\
	done
	for f in xlt pc164 ruffian; do					\
	    [ -f $(alpha_milo_dir)/milo-$$f ]				\
		|| (cd $(alpha_milo_dir)				\
			&& wget $(milo_url2)/milo-$$f )			\
		|| exit 1;						\
	done
# this is spelled out because for 2.2-18, subarch names don't fit
	ln -sf $(alpha_milo_dir)/milo-$(milo_version)-alcor	milo_alcor
	ln -sf $(alpha_milo_dir)/milo-$(milo_version)-xl	milo_xl
	ln -sf $(alpha_milo_dir)/milo-$(milo_version)-book1	milo_book1
	ln -sf $(alpha_milo_dir)/milo-$(milo_version)-avanti	milo_avanti
	ln -sf $(alpha_milo_dir)/milo-$(milo_version)-cabriolet	milo_cabriolet
	ln -sf $(alpha_milo_dir)/milo-$(milo_version)-eb164	milo_eb164
	ln -sf $(alpha_milo_dir)/milo-$(milo_version)-eb64p	milo_eb64p
	ln -sf $(alpha_milo_dir)/milo-$(milo_version)-eb66	milo_eb66
	ln -sf $(alpha_milo_dir)/milo-$(milo_version)-eb66p	milo_eb66p
	ln -sf $(alpha_milo_dir)/milo-$(milo_version)-lx164	milo_lx164
	ln -sf $(alpha_milo_dir)/milo-$(milo_version)-miata	milo_miata
	ln -sf $(alpha_milo_dir)/milo-$(milo_version)-mikasa	milo_mikasa
	ln -sf $(alpha_milo_dir)/milo-$(milo_version)-noname	milo_noname
	ln -sf $(alpha_milo_dir)/milo-$(milo_version)-p2k	milo_p2k
	ln -sf $(alpha_milo_dir)/milo-$(milo_version)-sx164	milo_sx164
	ln -sf $(alpha_milo_dir)/milo-$(milo_version)-takara	milo_takara

	ln -sf $(alpha_milo_dir)/milo-pc164			milo_pc164
	ln -sf $(alpha_milo_dir)/milo-ruffian			milo_ruffian
	ln -sf $(alpha_milo_dir)/milo-xlt			milo_xlt

	[ -f $(alpha_tools_dir)/linload.exe ] || \
	    ( cd $(alpha_tools_dir) && wget $(alpha_linload_url) )
	[ -f $(alpha_tools_dir)/ldmilo.exe ] || \
	    ( cd $(alpha_tools_dir) && wget $(alpha_ldmilo_url) -O ldmilo.exe )

	ln -sf $(alpha_tools_dir)/linload.exe
	ln -sf $(alpha_tools_dir)/ldmilo.exe

ifneq ($(alpha_apb_arches),)
	[ -f $(alpha_apb_dir)/apb.exe -a -f $(alpha_apb_dir)/up1000.pal ]  \
	    || ( mkdir -p $(alpha_apb_dir); cd $(alpha_apb_dir);	   \
		 wget $(alpha_apb_url) -O -				   \
		     | tar -xz apb.exe up1000.pal README.txt install.txt )

	ln -sf $(alpha_apb_dir)/apb.exe .
	ln -sf $(alpha_apb_dir)/up1000.pal .
	for i in $(alpha_apb_dir)/*.txt; do \
	    ln -sf $$i apb_$$(basename $$i); \
	done
endif
	$(MAKE) $(alpha_rescue_targets) $(alpha_drivers_targets) $(alpha_milo_targets)
ifeq ($(alpha_build_bootp),YES)
	$(MAKE) tftpboot.img root.tar.gz
endif
else
ifeq ($(architecture), arm) 
	for subarch in $(arm_arches); do \
		$(MAKE) kernel-$$subarch drivers$$subarch.tgz \
			rescue$$subarch.bin root$$subarch.bin; \
	done
	for subarch in $(arm_arches_tftp); do \
		$(MAKE) tftpboot-$$subarch.img; \
	done
	for subarch in $(arm_arches_nfsroot); do \
		$(MAKE) root$$subarch.tar.gz; \
	done
else
ifeq ($(architecture), ia64)
	$(MAKE) rootmckinley-smp.bin resc10000mckinley-smp.bin driversmckinley-smp.tgz
else
ifeq ($(architecture), mips)
	$(MAKE) driversr4k-ip22.tgz resc1440r4k-ip22.bin \
		tftpboot-r4k-ip22.img rootr4k-ip22.tar.gz
		 
else
ifeq ($(architecture), mipsel)
	$(MAKE) rootr4k-kn04.bin rootr4k-kn04.tar.gz
	$(MAKE) driversr4k-kn04.tgz resc1440r4k-kn04.bin resc2880r4k-kn04.bin
	$(MAKE) rootr3k-kn02.bin rootr3k-kn02.tar.gz
	$(MAKE) driversr3k-kn02.tgz resc1440r3k-kn02.bin resc2880r3k-kn02.bin
	# $(MAKE) -C mips-specials addinitrd
	# addinitrd does not work with most DECstation firmware revisions
else
ifeq ($(architecture), hppa)
	$(MAKE) resc288032.bin drivers32.tgz
	$(MAKE) resc288064.bin drivers64.tgz
else
ifeq ($(architecture), s390)
	$(MAKE) s390extras
	$(MAKE) roots390.bin roots390.tar.gz
	$(MAKE) resc2880s390.bin driverss390.tgz
	$(MAKE) linuxs390-tape
else
	echo unsupported architecture: $(architecture); false
endif
endif
endif
endif
endif
endif
endif
endif
endif
endif
endif
ifeq ($(USE_LANGUAGE_CHOOSER),true)
	$(MAKE) xlp.tgz
endif

release/README.txt: README-Users.m4
#	 make the top-level README
	[ -d release ] || mkdir release
	m4 --define=ARCHITECTURE=$(architecture) \
	   --define=RELNAME=$(debname) \
		$< > $@

release/READ-%.txt: README-Users.%.m4
#	 make the top-level README in any language
	[ -d release ] || mkdir release
	m4 --define=ARCHITECTURE=$(architecture) \
	   --define=RELNAME=$(debname) \
		$< > $@

.PHONY: release
release:	build docs
ifeq ($(architecture),alpha)
	./release.sh $(architecture) $(debname) $(debianversion) $(alpha_arches)	
else
ifeq ($(architecture),sparc)
	./release.sh $(architecture) $(debname) $(debianversion) $(generic_rootdisk_no_wildcard)
else
ifeq ($(architecture),arm)
	TOOLS_DIR=$(tools_dir) arm_arches="$(arm_arches)" arm_arches_tftp="$(arm_arches_tftp)" arm_arches_nfsroot="$(arm_arches_nfsroot)" arm_arches_rootbin="$(arm_arches_rootbin)" arm_arches_linux="$(arm_arches_linux)" ./release.sh $(architecture) $(debname) $(debianversion)
else
	TOOLS_DIR=$(tools_dir) ./release.sh $(architecture) $(debname) $(debianversion)
endif
endif
endif

.PHONY: umount
umount:
	-for d in ${tmpdir}/boot-floppies/mnt.*; do umount $$d; done;
#	 also need to unmount /dev/pts and /proc in base-tmp
#	 directories if the build was interrupted
	-find ${tmpdir}/boot-floppies -path '*/dev/pts' -o -path '*/proc' \
		-a -type d | xargs -r umount

.PHONY: cleanfiles
cleanfiles:
	rm -f *.bin *.tgz sys_map*.gz config*.gz linux* modcont* core	\
		root*.tar.gz *.img *.tmp *.o *.iso $(SFONT) xlp.tgz
	rm -f `find -name \*~` disks-$(architecture)
	rm -f `find -name '.#*'`
	rm -rf release updates

.PHONY: clean
clean:	cleanfiles
	set -e; for dir in utilities scripts/rootdisk/messages documentation \
			   powerpc-specials s390-specials ; \
		do \
		    $(MAKE) -C $$dir $@ ;\
		done
	$(ROOTCMD) $(MAKE) umount
	$(ROOTCMD) rm -rf $(tmpdir)/boot-floppies
# and drop the tarball with device files
#	rm -rf devtarball.tgz

.PHONY: cleanarchive
cleanarchive:
	$(ROOTCMD) rm -rf $(archive)

.PHONY: distclean
distclean:	clean cleanarchive
	$(MAKE) -C utilities distclean
	$(MAKE) -C documentation distclean

include make/keymaps
include make/modules
include make/checks
include make/root
include make/rescue
include make/drivers
include make/tftp
include make/utils

##
## optional file with special rules for this architecture
##
-include make/$(architecture).rules

sign:
	pgp +clearsig=on -fast <release/md5sum.txt >release/md5sum.tmp
	mv release/md5sum.tmp release/md5sum.txt

=== documentation/Makefile ===
# Makefile for documentation
# 
# See README-authors for more information.

.SUFFIXES:

-include ../config
-include Makefile.docs

# fdisk documentation to include (varies per platform)
FDISK_DOCS := $(shell grep -s "fdisk\|fdasd\|dasdfmt\|parted" \
		../scripts/rootdisk/SMALL_BASE_LIST_$(architecture) | \
		sed -e 's/^.*\/\(.*\)/\1.txt/' 2>/dev/null)

# set extension of source/dest files based on LINGUA
ifeq ($(LINGUA),C)
SRCEXT		:=
DESTEXT		:= .en
DESTDIRADD	:=
else
SRCEXT		:= .$(LINGUA)
DESTEXT		:= .$(LINGUA)
DESTDIRADD	:= $(LINGUA)
endif

ALLARCHINSTALLDIR := $(CURDIR)/arch

# programs for creating output
DEBIANDOC2HTML	:= debiandoc2html -l $(LINGUA) -c 
DEBIANDOC2PS	:= debiandoc2ps -l $(LINGUA)
DEBIANDOC2TEXT	:= debiandoc2text -l $(LINGUA) 
DEBIANDOC2LATEX	:= debiandoc2latex -l $(LINGUA)

# detailed sgml validation
NSGMLS		:= nsgmls -ges -wall $(DDOC)

# maximum times we're willing to run TeX to get cross-references right, if you subtract by 3
MAX_TEX_RECURSION	:= 6

# documents to build
TARGETDOCS := index.en.html			\
	      install$(DESTEXT).txt		\
	      install$(SRCEXT).html/install$(DESTEXT).html \
	      $(FDISK_DOCS)

ifneq "$(findstring $(LINGUA),$(dselect-beginner-langs))" ""
TARGETDOCS += dselect-beginner$(SRCEXT).html/dselect-beginner$(DESTEXT).html \
	      dselect-beginner$(DESTEXT).txt
endif

# you might want to remove this if it is failing for you
#   ja and ru documents are currently not converted into .pdf correctly 
ifneq ($(LINGUA),ja)
ifneq ($(LINGUA),ru)
TARGETDOCS	+= install$(DESTEXT).pdf
endif
endif

EXTRAFILES	:= officiallogo-nd-50.jpg openlogo-nd-50.jpg

# just an unreasonable default
DESTDIR		:= /tmp

ifeq ($(OFFICIALWEBBUILD),true)
# special build requirements for web building
install_file 	:= install -m 2664 -p
makedir		:= mkdir -p -m 2775
else
install_file	:= install -m 644 -p
makedir		:= mkdir -p -m 0755
endif

DEB_VERSION	:= $(shell cd .. && LC_ALL=C dpkg-parsechangelog |	\
			grep '^Version: ' | sed 's/^Version: *//')

# default date representation in documents
DATEFORM_$(LINGUA) := %d %B, %Y
# exceptions from the above rule:
DATEFORM_hr	:= %-d. %-m. %Y.
DATEFORM_da	:= %-d. %B %Y
DATEFORM_de	:= %-d. %b. %Y
DATEFORM_fr	:= %-d %B %Y
DATEFORM_ja	:= %Y/%m/%d

DATE		:= $(shell cd .. && date --date="`dpkg-parsechangelog |	\
			grep '^Date: ' | sed 's/^Date: *//'`" 		\
			'+$(strip $(DATEFORM_$(LINGUA)))')

# derived entity files
DERIVED_ENTS	:= messages.ent dynamic.ent
# this for is used for dependencies
ENT_DEPENDS	:= defaults.ent messages.ent dynamic.ent

define checklingua
  if [ -z "$(LINGUA)" ]; then \
  echo LINGUA variable is not set -- see documentation/README-authors; \
  exit 1; \
  fi
endef

# actual rules start here
# (note: default rule is the default one from Makefile.docs, not this one)
.PHONY:	all
all:	supplemental_makefile $(TARGETDOCS) $(EXTRATARGETDOCS)

.PHONY: lint
lint:	$(ENT_DEPENDS)
ifneq "$(wildcard install$(SRCEXT).sgml)" ""
	@echo "Verifying SGML validity for Installation Manual, language $(LINGUA):"
	$(NSGMLS) install$(SRCEXT).sgml
#	@echo "Checking for deprecated entity references:"
#	nsgmls -oentity /usr/lib/sgml/declaration/debiandoc.decl \
#	  install$(SRCEXT).sgml 2>/dev/null | sed -e '/^IMSG/!d' -e 's/^I/   /'
endif
ifneq "$(wildcard dselect-beginner$(SRCEXT).sgml)" ""
	@echo "Verifying SGML validity for dselect Documentation for Beginners, language $(LINGUA):"
	$(NSGMLS) dselect-beginner$(SRCEXT).sgml
endif
ifneq "$(wildcard release-notes$(SRCEXT).sgml)" ""
	@echo "Verifying SGML validity for Release Notes, language $(LINGUA):"
	$(NSGMLS) release-notes$(SRCEXT).sgml
endif

# check SGML validity for the documentation, one language
.PHONY: lint-docs
lint-docs: supplemental_makefile
	set -e; for arch in $(arches); do \
	  echo "** verifying SGML for $$arch architecture"; \
	  $(MAKE) architecture=$$arch lint; \
	  echo; \
	done

# check SGML validity for the documentation, all languages
.PHONY: lint-all-lang-docs
lint-all-lang-docs:
	set -e; for lang in $(installmanual-langs); do \
	  echo "** verifying SGML for language $$lang"; \
	  $(MAKE) LINGUA=$$lang lint-docs; \
	  echo; \
	done

.PHONY:	validate
validate:	$(ENT_DEPENDS)
	@set -ex; for i in *.sgml; do $(NSGMLS) $$i; done

.PHONY:	supplemental_makefile
supplemental_makefile:
	@$(checklingua)
	@[ ! -f $(LINGUA)/Makefile ] || $(MAKE) -C $(LINGUA)

# generate the nice index page.
# FIXME: is m4 really the right way to do this?
ifneq "$(wildcard index$(DESTEXT).html.m4)" ""
index$(DESTEXT).html: index$(DESTEXT).html.m4; m4 \
 --define=ARCHITECTURE=${architecture} \
 --define=OFFICIAL=${OFFICIALWEBBUILD} \
    $< > $@
else
.PHONY: index$(DESTEXT).html index.en.html
endif

# this will probably only work if your name is "Adam Di Carlo"
.PHONY: ChangeLog
ChangeLog:
	cvs2cl.pl --tags --branches --revisions --utc	\
	  --usermap $$HOME/debian/boot-floppies/CVSROOT/users

# generic rules for all the languages and output formats -- Installation Manual.
ifneq "$(wildcard install$(SRCEXT).sgml)" ""
install$(SRCEXT).html/install$(DESTEXT).html:	install$(SRCEXT).sgml	\
						$(ENT_DEPENDS)
	$(DEBIANDOC2HTML) -t install $<

install$(DESTEXT).txt:	install$(SRCEXT).sgml $(ENT_DEPENDS)
	$(DEBIANDOC2TEXT) -O $< > $@

install$(DESTEXT).ps:	install$(SRCEXT).sgml $(ENT_DEPENDS)
	$(DEBIANDOC2PS) -O $< > $@

install$(DESTEXT).tex:	install$(SRCEXT).sgml $(ENT_DEPENDS)
	$(DEBIANDOC2LATEX) -O $< > $@
else
.PHONY: install$(SRCEXT).html/install$(DESTEXT).html install$(DESTEXT).txt \
        install$(DESTEXT).ps install$(DESTEXT).tex install$(DESTEXT).pdf
endif

# generic rule for all the PDFs
%.pdf:	%.tex
#	 note that I have seen bi-stable .aux files, thus we check two levels deep
	-cp -pf prior.aux pprior.aux 2>/dev/null
	-cp -pf $(basename $<).aux prior.aux 2>/dev/null
#	 fail if we don't have pdflatex correctly installed
	kpsewhich pdflatex.fmt >/dev/null
#	 due to a bug in debiandoc2latex2e output, this might fail
	-pdflatex '\nonstopmode\input{$<}' >/dev/null # see $(@:.pdf=.log) for details
	@set -e								;\
	if ! cmp $(basename $<).aux prior.aux 2>/dev/null &&		\
	   ! cmp $(basename $<).aux pprior.aux 2>/dev/null; then	\
		if expr $(MAKELEVEL) '<' $(MAX_TEX_RECURSION) >/dev/null;\
		then							\
		   echo "remaking $@ (take $(MAKELEVEL))"		;\
		   rm -f $@						;\
		   $(MAKE) $@						;\
		else							\
		   echo "E: $@ needs remaking, but we have reached max. level, $(MAX_TEX_RECURSION)" ;\
		fi							\
	fi
	rm -f prior.aux pprior.aux

# generic rules for all the languages and output formats -- dselect Documentation for Beginners
ifneq "$(wildcard dselect-beginner$(SRCEXT).sgml)" ""
dselect-beginner$(SRCEXT).html/dselect-beginner$(DESTEXT).html:		\
		dselect-beginner$(SRCEXT).sgml $(ENT_DEPENDS)
	$(DEBIANDOC2HTML) -t dselect-beginner $<

dselect-beginner$(DESTEXT).txt:	dselect-beginner$(SRCEXT).sgml $(ENT_DEPENDS)
	$(DEBIANDOC2TEXT) -O $< > $@

dselect-beginner$(DESTEXT).ps:	dselect-beginner$(SRCEXT).sgml $(ENT_DEPENDS)
	$(DEBIANDOC2PS) $<

dselect-beginner$(DESTEXT).tex:	dselect-beginner$(SRCEXT).sgml $(ENT_DEPENDS)
	$(DEBIANDOC2LATEX) -O $< > $@
else
.PHONY: dselect-beginner$(SRCEXT).html/dselect-beginner$(DESTEXT).html \
        dselect-beginner$(DESTEXT).txt dselect-beginner$(DESTEXT).ps \
        dselect-beginner$(DESTEXT).tex dselect-beginner$(DESTEXT).pdf
endif

# these rules generate text files out of *fdisk programs' manpages
cfdisk.txt:
	./man2text $(ftp_archive) cfdisk 8 util-linux > $@

cfdisk-utf8.txt: cfdisk.txt
	cp -a cfdisk.txt cfdisk-utf8.txt

fdisk.txt:
	./man2text $(ftp_archive) fdisk 8 util-linux > $@

atari-fdisk.txt:
	./man2text $(ftp_archive) atari-fdisk 8 atari-fdisk > $@

amiga-fdisk.txt:
	./man2text $(ftp_archive) amiga-fdisk 8 amiga-fdisk > $@

mac-fdisk.txt:
	./man2text $(ftp_archive) mac-fdisk 8 mac-fdisk > $@

pmac-fdisk.txt:
	./man2text $(ftp_archive) pmac-fdisk 8 pmac-fdisk-cross > $@

dasdfmt.txt:
	./man2text $(ftp_archive) dasdfmt 8 s390-tools > $@

fdasd.txt:
	./man2text $(ftp_archive) fdasd 8 s390-tools > $@

parted.txt:
	./man2text $(ftp_archive) parted 8 parted > $@

.PHONY: install
install:
	set -e								;\
	for lang in $(installmanual-langs); do				 \
	    echo "installing $$lang"					;\
	    $(MAKE) LINGUA=$$lang install-lang				;\
	done

.PHONY:	install-lang
install-lang:
ifneq ($(OFFICIALWEBBUILD),true)
# DESTDIRADD is used to install in a subdirectory,
# to make things easier to find
	$(makedir) $(DESTDIR)/$(DESTDIRADD)
	$(install_file) $(TARGETDOCS) $(EXTRAFILES) \
          $(wildcard dselect-beginner$(SRCEXT).html/* install$(SRCEXT).html/*) \
          $(DESTDIR)/$(DESTDIRADD)
# makes index.html symlink to index.??.html
# (can't do this with the wildcard function because it will be evaluated
# before the command from the previous line installs these files)
	ln -sf `basename $(DESTDIR)/$(DESTDIRADD)/index.??.html` \
               $${file%$${$$(basename $$file)#index}}.html
else
# simply installs files into one directory, for the official web build
	$(makedir) $(ALLARCHINSTALLDIR)/$(architecture)
	$(install_file) $(TARGETDOCS) $(EXTRAFILES) \
          $(wildcard dselect-beginner$(SRCEXT).html/* install$(SRCEXT).html/*) \
          $(ALLARCHINSTALLDIR)/$(architecture)
# setting up our nice content-negotiation symlinks
ifeq "$(LINGUA)" "C"
	for file in $(ALLARCHINSTALLDIR)/$(architecture)/*.en.*; do \
          ln -sf `basename $$file` $${file%.en.html}.html; \
        done
endif
endif

.PHONY:	clean
clean:
	rm -f $(DERIVED_ENTS) dynamic_*.ent messages*.ent
	rm -rf *.html
	rm -f *.txt *.tex *.dvi *.pdf *.ps
	rm -f *.log *.aux *.bak *.out *.sasp* *.toc
	rm -f doc.stamp
	set -e ; for dir in `find . -type d -mindepth 1 -maxdepth 1`; do \
	    [ ! -f $$dir/Makefile ] || $(MAKE) -C "$$dir" $@		;\
	done

.PHONY:	distclean
distclean: clean
	rm -f *~ *.orig \#*
	rm -rf $(ALLARCHINSTALLDIR)
	rm -rf upgrade-*
	rm -f relnotes.tar.bz2


# generate entities which are dynamically defined by the settings of this
# build run, generally set in the top-level config file
dynamic_$(LINGUA)_$(architecture).ent: ../debian/changelog
ifeq "$(architecture)" ""
	@echo architecture variable is not set -- see documentation/README-authors
	exit 1
endif
ifeq "$(findstring $(architecture), $(arches))" ""
	@echo architecture variable is set to something strange, edit ../config
	exit 1
endif
	: > $@			# clear the file
	echo "<!entity docversion       \"$(DEB_VERSION)\">" >> $@
	echo "<!entity docdate          \"$(DATE)\">" >> $@
	echo "<!entity language         \"$(LINGUA)\">" >> $@
	echo "<!entity langext          \"$(DESTEXT)\">" >> $@
	echo "<!entity release          \"$(debianversion)\">" >> $@
	echo "<!entity releasename      \"$(debname)\">" >> $@
	echo "<!entity kernelversion    \"$(kver)\">" >> $@
	echo "<!entity altkernelversion \"$(altkver)\">" >> $@
	echo "<!entity architecture     \"$(architecture)\">" >> $@
	echo "<!entity % $(architecture) \"INCLUDE\">" >> $@
	echo "<!entity % lang-$(shell echo $(LINGUA) | sed 's/_//') \"INCLUDE\">" >> $@
	set -e; for i in $(FDISK_DOCS); do			    \
		echo "<!entity % $$i    \"INCLUDE\">" >> $@;\
	done
ifeq ($(OFFICIALWEBBUILD),true)
	echo "<!entity % official-web-build \"INCLUDE\">" >> $@
	echo "<!entity path-to-top-level \"\">" >> $@
else
	echo "<!entity % official-web-build \"IGNORE\">" >> $@
# figure out how we get to the top level, for downloadable-files
# entity in defaults.ent; non-English goes into a subdir in docs so we
# need to allow for that
ifneq ($(OFFICIALWEBBUILD),true)
ifeq "$(LINGUA)" "C"
	echo "<!entity path-to-top-level \"../\">" >> $@
else
	echo "<!entity path-to-top-level \"../../\">" >> $@
endif
else
	echo "<!entity path-to-top-level \"\">" >> $@
endif
endif

.PHONY: dynamic.ent
dynamic.ent:	dynamic_$(LINGUA)_$(architecture).ent
	rm -f $@
	ln -s $< $@

# in case LINGUA isn't set, give a decent err message
$(DBOOTSTRAP_DIR)/po/.po:
	@$(checklingua)

# unlike its translations, C.po isn't static, it's autogenerated
$(DBOOTSTRAP_DIR)/po/C.po:
	$(MAKE) -C $(DBOOTSTRAP_DIR)/po C.po

=== powerpc-specials/Makefile ===
# Makefile for PowerPC install documentation
#
# Docs are english version and TXT for now
# but could be html, ps or pdf

-include ../config

# ifeq ($(LINGUA),C)
   LINGUA := en
# endif

all:
	debiandoc2text install-chrp.$(LINGUA).sgml
	debiandoc2text install-pmac.$(LINGUA).sgml
	debiandoc2text install-prep.$(LINGUA).sgml
	debiandoc2text install-apus.$(LINGUA).sgml

clean:
	rm -f install-*.txt ybin*

=== s390-specials/Makefile ===
#
# This file is subject to the terms and conditions of the GNU General Public
# License.  See the file copyright in the debian subdirectory of this archive
# for more details.
#
# Copyright (C) 2001 by Gerhard Tonn and Stefan Gybas
#

CC := gcc
CFLAGS := -Wall -Werror -pipe -O2

all: netsetupcalc login changrep

netsetupcalc: netsetupcalc.c
	$(CC) $(CFLAGS) -o $@ $^

login: login.c
	$(CC) $(CFLAGS) -o $@ $^

changrep: changrep.c
	$(CC) $(CFLAGS) -o $@ $^

s390extras: all

clean:
	rm -f netsetupcalc login changrep

.PHONY: s390extras clean

=== utilities/Makefile ===

include ../config

CC			:= gcc
ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
CFLAGS			:= -O2 -g
else
CFLAGS			:= -O2 -fomit-frame-pointer
endif
LDFLAGS			:= -s
arch			:= $(shell dpkg --print-architecture)

SUBDIRS	:= libfdisk dbootstrap writemaps

ifeq ($(USE_LANGUAGE_CHOOSER),true)
# bogl enabled
SUBDIRS	+= bogl
endif

SPLIT_OBJECTS	:= floppy_split.o

all:		floppy_split $(SUBDIRS)

.PHONY:		$(SUBDIRS)
$(SUBDIRS):
	$(MAKE) -C $@ KVER=${KVER} KERNEL_VERSION_CODE=${KERNEL_VERSION_CODE}

clean:
	rm -f *.o *.bak po.utf rn.utf all.utf
	rm -f floppy_split
	set -e; for i in $(SUBDIRS); do $(MAKE) -C $$i clean; done

distclean: clean
	set -e; for i in $(SUBDIRS); do $(MAKE) -C $$i distclean; done

floppy_split: $(SPLIT_OBJECTS)
	$(CC) $(LDFLAGS) -o $@ $(SPLIT_OBJECTS)

# dependancies
$(SPLIT_OBJECTS):	floppy_split.h

=== documentation/fi/Makefile ===
# This makefile assumes debiandoc-sgml version 1.1.18 or later,
# so that the generated files are .tov, .txt etc 3-letter extensions. 
# Tapio Lehtonen <tale@iki.fi> 1999-04-13

all:	dictionary-finnish-english.ent dictionary-english-finnish.ent

sanakirja.suomi-englanti: dictionary.master
	cat dictionary.master | awk -v FS='\t' \
		'{printf "%s\t%s\n",$$2,$$1}' | \
		sort -f > sanakirja.suomi-englanti

dictionary-finnish-english.ent: sanakirja.suomi-englanti
	cat sanakirja.suomi-englanti | awk -v FS='\t' \
	'BEGIN{printf "<taglist compact>\n"}\
	{printf "<tag>%s\t<item>%s\n",$$1,$$2}\
	END{printf "</taglist>\n"}' > dictionary-finnish-english.ent

sanakirja.englanti-suomi: dictionary.master
	cat dictionary.master | sort -f > sanakirja.englanti-suomi

dictionary-english-finnish.ent: sanakirja.englanti-suomi
	cat sanakirja.englanti-suomi | awk -v FS='\t' \
	'BEGIN{printf "<taglist compact>\n"}\
	{printf "<tag>%s\t<item>%s\n",$$1,$$2}\
	END{printf "</taglist>\n"}' > dictionary-english-finnish.ent

clean:	
	rm -f sanakirja.englanti-suomi sanakirja.suomi-englanti
	rm -f dictionary-finnish-english.ent dictionary-english-finnish.ent

=== powerpc-specials/coffboot/Makefile ===
CC      = $(CROSS_COMPILE)gcc
HOST_CC = gcc
LD      = $(CROSS_COMPILE)ld
CFLAGS  = -O -fno-builtin
OBJCOPY = $(CROSS_COMPILE)objcopy
OBJCOPY_ARGS = -O aixcoff-rs6000 -R .stab -R .stabstr -R .comment --add-section=image=vmlinux.gz
LD_ARGS = -e _start -T ld.script -Ttext 500000 -Tdata 510000 -Bstatic
GZ = gzip -9

OBJS = crt0.o ctype.o errno.o start.o main.o misc.o string.o vsprintf.o zlib.o

coffboot: $(OBJS) ld.script
	$(LD) -o coffboot $(LD_ARGS) $(OBJS)

hack-coff: hack-coff.c
	$(HOST_CC) $(CFLAGS) -o hack-coff hack-coff.c

vmlinux.gz: ../../linuxpmac.bin
	$(OBJCOPY) -S -O binary ../../linuxpmac.bin vmlinux
	gzip -9fv vmlinux

ramdisk.image.gz: ../../rootpmac.bin
	cp $< $@

../../rescue-pmac.coff: coffboot hack-coff vmlinux.gz ramdisk.image.gz
	$(OBJCOPY) $(OBJCOPY_ARGS) --add-section=initrd=ramdisk.image.gz coffboot $@
	./hack-coff $@

clean:
	rm -f coffboot hack-coff vmlinux.gz ramdisk.image.gz *.o *~

=== utilities/bogl/Makefile ===
include ../../config

include ../dbootstrap/langs/Makefile.genlangs

xml_files=$(addprefix ../dbootstrap/langs/,$(generated_languages))

all:    unifont-reduced.bgf

unifont-reduced.bgf: unifont-reduced.bdf
	bdftobogl -b $< > $@

unifont-reduced.bdf: /usr/src/unifont.bdf all.utf
	LC_ALL=en_IN.UTF-8 reduce-font $< < all.utf > $@

all.utf: po.utf rn.utf $(xml_files) graphic.utf
	cat $^ > $@

$(xml_files):
	$(MAKE) -C ../dbootstrap/langs

po.utf:
	$(MAKE) -C ../dbootstrap/po all-po-utf
	cat ../dbootstrap/po/utf/*.po > $@

rn.utf:
	$(MAKE) RN_TARGET_DIR=. -C ../../scripts/rootdisk/messages install-utf
	cat ../../scripts/rootdisk/messages/release_notes.* > $@

clean: 
	rm -f unifont-reduced.bgf unifont-reduced.bdf rn.utf po.utf all.utf

distclean: clean
	rm -f *~ .nfs*

# delete files when there's an error
.DELETE_ON_ERROR:

=== utilities/dbootstrap/Makefile ===
# Makefile for dbootstrap
#
# Yes, we like rewriting this makefile over and over again....

# Some things we can set to change compilation:
# DEBUG=true	- turns on debugging (-g)
# SMALL=true	- turns on size optimizations (-Os -fomit-frame-point)
# LC=true	- turns on language chooser
#		  This needs to agree with USE_LANG_CHOOSER
# FB=true	- turns on "graphical" verson of dbootstrap
# EFENCE=true	- compile with efence
# POINTERIZE=false = turns off translations

-include ../../config

# These are the default values:
DEBUG	?= false
SMALL	?= true
LC = $(USE_LANGUAGE_CHOOSER)
FB	?= false
EFENCE	?= false
POINTERIZE ?= true
LINGUA	?= C
ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
DEBUG	:= false
SMALL	:= false
endif

# General compiler stuff
CC	 := gcc
CFLAGS	 := -Wall -D_GNU_SOURCE -pipe -I. $(EXTRA_CFLAGS) 
LDFLAGS	 :=
BFLIBS	 := ../libfdisk/libfdisk.a
LIBS	 := -lloadtrm $(BFLIBS) -lnewt -lslang
ifeq ($(LC),true)
BUILD	 := build-lc/
else
BUILD	 := build/
endif

ifeq ($(DEBUG),true)
CFLAGS	+= -g -DDEBUG
LDFLAGS	+=
STRIP	:= :
else
ifeq ($(SMALL),true)
CFLAGS	+= -Os -fomit-frame-pointer -fno-builtin
LDFLAG	+=
STRIP	:=  strip --remove-section=.note --remove-section=.comment
else
CFLAGS	+= -O2
STRIP	:= :
endif
endif

# for euc-jp encoded japanese string
ifeq ($(LINGUA),ja)
USE_SHRINK_STRING = true
endif
ifdef USE_SHRINK_STRING
CPPFLAGS	+= -DUSE_SHRINK_STRING
OBJECT_SS	+= shrink_string.o
endif

ifeq ($(EFENCE),true)
LIBS	+= -lefence
endif

ifeq ($(LC),true)
CFLAGS	+= -DUSE_LANGUAGE_CHOOSER -DUSE_LANGUAGE_VARIANTS -DUTF8
endif

ifdef KBD
CFLAGS += -DKBD=\"$(KBD)\"
endif

ifeq ($(FB),true)
CFLAGS	+= -DGRAPHICAL
LIBS	+= /usr/lib/libbogl.a
endif

# constants
ifeq ($(LC),true)
DBOOTSTRAP	:= dbootstrap-lc
else
DBOOTSTRAP	:= dbootstrap
endif
BUILDTIME	:= $(shell TZ=UTC date --utc "+%Y.%m.%d-%H:%M%z")
ifndef KERNEL_VERSION_CODE
# fake it... (2.2)
KERNEL_VERSION_CODE := $(shell echo $$((2 * 65535 + 2 * 256)))
endif

CFLAGS	+= -DBUILDTIME='"$(BUILDTIME)"' -DARCHNAME='"$(architecture)"'
CFLAGS	+= -DKERNEL_VERSION_CODE=${KERNEL_VERSION_CODE} -DKVER='"${KVER}"'
ifdef FONT
CFLAGS	+= -DFONT='"$(FONT)"'
endif

# Default build target:
all: $(DBOOTSTRAP) po/po_stamp

# Targets
DBOOTSTRAP_MODULES	:= $(subst .c,,$(wildcard *.c))
TEST_MODULES		:= interactive_shell	\
			   boxes		\
			   release_notes	\
			   main_menu		\
			   kbdconfig		\
			   choose_medium	\
			   floppy_merge		\
			   pcmcia		\
			   netconfig		\
			   tzconfig		\
			   partition_config	\
			   select_not_mounted	\
			   bootconfig		\
			   reboot_system	\
			   net-fetch

ifeq ($(POINTERIZE),false)
SRCEXT			:= c
OBJEXT			:= o
else
SRCEXT			:= t.c
OBJEXT			:= to
LANG_H			:= lang.h
endif
DBOOTSTRAP_TARGETS	= $(addprefix $(BUILD),$(addsuffix .$(OBJEXT),$(DBOOTSTRAP_MODULES)))
TEST_TARGETS		= $(addprefix $(BUILD),$(addsuffix .$(OBJEXT),$(TEST_MODULES)))

ifeq ($(LC),true)
DBOOTSTRAP_TARGETS += langs/langs.o
langs/langs.o:
	$(MAKE) -C langs
endif

# Rules
ifneq ($(BUILD),)
$(BUILD):
	@test -d $(BUILD) || mkdir -p $(BUILD)
endif

show_settings:
	@echo Compilation settings:
	@echo CC	= $(CC)
	@echo CFLAGS	= $(CFLAGS)
	@echo LDFLAGS	= $(LDFLAGS)
	@echo LIBS	= $(LIBS)
	@echo BUILD	= $(BUILD)
	@echo DEBUG	= $(DEBUG)
	@echo SMALL	= $(SMALL)
	@echo LC	= $(LC)
	@echo FB	= $(FB)
	@echo EFENCE	= $(EFENCE)
	@echo POINTERIZE = $(POINTERIZE)
	@echo LINGUA	= $(LINGUA)

# i18n stuff
po/po_stamp:
	make -C po

po/%:
	make -C po $(notdir $@)

$(OBJECT_SS) :
	$(MAKE) -C shrink_string LINGUA="$(LINGUA)"

# libraries
$(BFLIBS):
	$(MAKE) -C $(dir $@) $(notdir $@)

# object build rules
# Generate dependencies (these are included at the end of this file 
$(BUILD)%.d: %.c
	gcc -MM $(CFLAGS) $< | sed -e "1s/.*:/$(subst /,\\/,$@):/" > $@

# Translations...
$(BUILD)%.t.c: %.c po/$(LINGUA).mo
	@echo "#line 1 \"$<\"" > $@
	pointerize -m po/$(LINGUA).mo -m po/C.mo < $< >> $@

$(BUILD)%_test.$(OBJEXT): CFLAGS += -D_TESTING_
$(BUILD)%_test.$(OBJEXT): $(BUILD)%.$(SRCEXT) $(BUILD)%.d $(LANG_H)
	$(CC) $(CFLAGS) -c -o $@ $<

$(BUILD)%.$(OBJEXT): $(BUILD)%.$(SRCEXT) $(BUILD)%.d $(LANG_H)
	$(CC) $(CFLAGS) -c -o $@ $<

lang.h: po/C.mo
	gen-header $<
	echo >> $@

test.trm: po/$(LINGUA).trm
	cp $^ $@

# dbootstrap and dbootstrap_test
$(BUILD)$(DBOOTSTRAP)_test: CFLAGS += -D_EXETESTING_
$(BUILD)$(DBOOTSTRAP) $(BUILD)$(DBOOTSTRAP)_test: $(BUILD) $(DBOOTSTRAP_TARGETS) $(BFLIBS)
	$(CC) -o $@ $(DBOOTSTRAP_TARGETS) $(LDFLAGS) $(LIBS)
	$(STRIP) $@

# unit test targets, e.g. main_menu_test
$(BUILD)%_test: $(BUILD) $(BUILD)main_test.$(OBJEXT) \
	$(BUILD)%_test.$(OBJEXT) $(DBOOTSTRAP_TARGETS) test.trm
	$(CC) -o $@ $(BUILD)main_test.$(OBJEXT) $(BUILD)$*_test.$(OBJEXT) \
		$(filter-out $< $(BUILD)main.$(OBJEXT) $(BUILD)$*.$(OBJEXT),$(DBOOTSTRAP_TARGETS)) $(LDFLAGS) $(LIBS)
	$(STRIP) $@

# this is just for convenience to move things from the build directory
# back to the source (this is meant only for the final target, not the intermediates)

ifneq ($(BUILD),)
%: $(BUILD)%
	cp $(BUILD)$@ $@
endif

# Clean rules
.PHONY: clean
clean:
	$(MAKE) -C po $@
	$(MAKE) -C langs $@
	rm -f $(DBOOTSTRAP) $(BUILD)$(DBOOTSTRAP) *_test dbootstrap-lc
	rm -f $(BUILD)*.o $(BUILD)*.to $(BUILD)*.t.c $(BUILD)*_test $(BUILD)*.d

distclean: clean
	$(MAKE) -C po $@
	$(MAKE) -C langs $@
	rm -f lang.h test.trm C.mo kbddefault.h
	test -z "$(BUILD)" || rm -rf $(BUILD)

.PHONY: all all_potato all_woody clean distclean

The_DFiles = $(wildcard $(BUILD)*.d)
ifneq ($(words $(The_DFiles)),0)
include $(The_DFiles)
endif

$(DBOOTSTRAP):	$(BUILD)$(DBOOTSTRAP)

=== utilities/libfdisk/Makefile ===
KVER =
LIBS = -lc #-lefence

CC = gcc

CFLAGS = -Wall -Os -fomit-frame-pointer -fno-builtin
# CFLAGS = -Wall -O2 -fomit-frame-pointer

# CFLAGS = -Wall -O2
# CPPFLAGS = -DARCH="i386"

# CFLAGS = -Wall -O2
# CPPFLAGS = -DARCH="m68k"

ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
CFLAGS += -g3
CPPFLAGS += -DDEBUG
endif

ifneq ($(findstring 2.0.,$(KVER)),)
CPPFLAGS += -DOLDKERNEL
endif

PROGS =

OBJS = fdisk.o partbl_msdos.o partbl_osf.o partbl_sun.o partbl_amiga.o \
       partbl_atari.o partbl_mac.o partbl_acorn.o partbl_sgi.o partbl_ibm.o \
       partbl_gpt.o

HEADERS = fdisk.h byteorder.h config.h
SOURCES = $(OBJS:%.o=%.c) testing.c

all: libfdisk.a $(PROGS)

libfdisk.a: $(OBJS)
	$(AR) rcs $@ $(OBJS)

testing: testing.o libfdisk.a
	$(CC) $(LDFLAGS) -o testing $^ $(LIBS)

depend:	$(SOURCES:%.c=.depend/%)

clean: 
	rm -f $(PROGS) $(OBJS) libfdisk.a testing.o testing

distclean: clean
	rm -rf .depend

__deB-ORG := $(shell if [ -f .depend ];		\
		     then			\
			rm .depend;		\
		     elif [ ! -d .depend ];	\
		     then			\
			 mkdir .depend;		\
		     fi)

.depend/% : %.c
	set -e;					\
	  echo $@ : $< > $@;			\
	  echo >> $@;				\
	  $(CC) -MM $(CPPFLAGS) $*.c >> $@;	\
	  touch -m $@;

include $(SOURCES:%.c=.depend/%)

=== utilities/writemaps/Makefile ===
DATADIR ?= /usr/share
BINDIR ?= /usr/bin

PROGS   = loadkeys 

WARN	= -Wall
DEFS	= -DDATADIR=\"$(DATADIR)\"
CFLAGS  = -O2
ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
  CFLAGS += -g
endif
LDFLAGS = -s

CC	= gcc
YACC	= bison -y
LEX	= flex -8

default:	$(PROGS)

.c.o:
	$(CC) -c $(WARN) $(CFLAGS) $(DEFS) $<

all: $(PROGS)

# loadkeys.o: separate rule since the flex output does not permit -Wall
loadkeys.o:	loadkeys.c analyze.c
	$(CC) -c $(CFLAGS) $(DEFS) $<


distclean clean:
	rm -f core *.o analyze.c loadkeys.c loadkeys

$(PROGS): %: %.o

loadkeys: ksyms.o findfile.o getfd.o

ksyms.o: cyrillic.syms.h ethiopic.syms.h

loadkeys.o: paths.h

=== scripts/rootdisk/messages/Makefile ===
# This file allows installation of UTF versions of release_notes...

# Note: If you get an error about no target available for release_notes.xx , 
# there might have been a language added since your last visit. 
# To remedy, cvs up -dPAR

RN_TARGET_DIR ?= .

available_languages = $(shell awk '{ print $$1 }' < languages)
dests = $(addprefix $(RN_TARGET_DIR)/release_notes.,$(available_languages))

default:
	@echo please check Makefile to see the available options
	@echo BTW, available languages are: $(available_languages)
	@echo BTW, dests are: $(dests)

$(RN_TARGET_DIR)/release_notes.en: C/release_notes
	install -m 0644 $< $@

$(RN_TARGET_DIR)/release_notes.%: %/release_notes
	iconv -f $(shell grep ^`dirname $<` languages | awk '{ print $$2 }') -t utf-8 < $< > $@

.PHONY : clean
clean:
	rm -f release_notes.en
	rm -f $(dests)

install-utf: $(RN_TARGET_DIR)/release_notes.en $(dests)

# if we fail on the iconv, remove the output as well
.DELETE_ON_ERROR:

=== debian/changelog ===
boot-floppies (3.0.23) unstable; urgency=low

  * Falk Hueffner:
    - Alpha: Use newer MILO images for pc164, ruffian and xlt. The older ones
      didn't work at all, so this shouldn't break anything
    - add myself as Alpha maintainer, remove inactive maintainers
  * Eduard Bloch:
    - German dbootstrap translation updates
    - documented keytimer option, USB keyboard instructions 
    - changed the f6 boot message to show the keytimer option
    - changed f5 to show noapic option, and more general comment about modules
    - German release notes updated
    - changed SUITE (dbootstrap_settings) to woody
    - reviewed and repaired the initrd creating code (broken linuxrc handling,
      broken size calculation, broken real-root calculation, nowadays useless
      anyways); closes: #143046, #105621
    - modified udbootstrap to export TERM=vt102 where needed,
      closes: #142357, #142305
    - rewrote the other-boot-partitions-show dialog to look less confusing,
      closes: #140980 since we do not add new features
    - removed -q option from mkreiserfs call (obsolete)
    - made the mount routine fall back on reiserfs/ext2/3 check when XFS mount
      failed, closes: #142481
    - support for i2o-scsi devices, still needing a newer/patched makedev
    - changed german string in i18n chooser, request from Thomas Bliesener
  * Guido Guenther
    - add myself to the maintainers file for MIPS
    - remove addinitrd source from boot-floppies - we have a mips-utils 
      package for that now
    - remove last references to mips-specials
    - mips: make sure we pick the correct linux.bin in release.sh
    - mips: someone changed linux to linux.bin in run_dvhtool; this "breaks"
      hd booting on mips, change reverted
  * Adam Di Carlo
    - docs: talk about language chooser step for those arches which have
      it; correct some problems in "supports dhcp" list; many SGML fixups
      in the translated manuals; move URLS into language-independant
      urls.ent; fix some URLS thanks to notification from James A. Treacy
    - Maintainers: small updates
    - alpha: build fix, the whole linux -> linux.bin thing
    - remove stale release notes from the sources, they were so old as to
      be useless anyhow; removed were de hr ja pl ru sk
    - enable Czech, Portuguese, Spanish and French release notes
    - enable Portuguese Install Manual
    - root fs building requires whiptail* and libnewt* 0.50.17-9.6 or
      better
    - install.bat disabled for bf2.4 until loadlin is fixed
  * Phil Blundell
    - fix problems with RiscPC keyboard during base-config
    - stamp out linux*.bin from .changes file on arm
    - docs: update package counts in defaults.ent
  * Ethan Benson
    - verify powerpc mount points even for non-Linux native partitions
  * Stefan Gybas
    - s390: remove unneeded linux*.bin files in release directory
    - s390 documentation updates
  * Adam C Powell: belated credit for arm boot instructions
  * David Kimdon
    - add some more menuBox TRANS hints,  changed suggested length 
      from ~70 to ~63 characters so boxes don't extend off the screen
  * Josip Rodin: changes to help with the production of web site docs
  * Matt Zimmerman
    - note use of rarpd for 2.4 kernels rather than kernel module;
      closes: #141102
    - correct debootstrap log path in S/390 issue; closes: #144566
  * Ben Collins
    - debootstrap msg was wrong -- SILO can and always has handled ext3
    - use piggyback for sparc tftp images instead of TILO
  * Erik Andersen: dbootstrap prevents kernel msgs from showing on console
  * Richard Hirst
    - change PA/RISC to PA-RISC; closes: #143991
    - ia64: increase initrd size to handle additional zh_TW language
    - add "nolangchooser" boot option to disable framebuffer
      since video=vga16:off doesn't work on all systems (e.g., m68k, hppa)
    - document nolangchooser in f7.txt and manual under dbootstrap options
    - doc build fixes
  * Santiago Vila
    - do not place unnecessary `defaults' in fstab; closes: #146479
  * Matt Kraai
    - document base system images
    - fix kernel install to/from NFS partition; closes: #142267
    - remove Nvidia bashing from manual; closes: #141497
    - correct driver disk counts; closes: #142993 
  * Rod Stewart: corrections to arm boot instructions
  * Chris Tillman
    - grab applicable stuff from GPL'd Progeny manual
    - document loadlin/bf2.4 problem
    - fix /usr/doc references, add MacOS partitioning recommends
    - add hints for manual booting from powerpc CD and install-safe
    - remove Amiga & MacOS 68k linux partition creation instructions
    - add model numbers and link for nubus pmacs
    - run ispell on all English sgml docs, no meanings changed
    - add CD #1 isolinux comment, and musical chairs with CD kernel images 
    - incorporate debian-mac.txt and remove it from cvs
    - add shutdown section in post-install and SLIP notes 
    - hacked Eduard's mini-iso.sh script for powerpc
    - added suggestions for powerpc modules to pick
    - add warning about CONFIG_DEVFS to docs; closes: #139418
    - remove Make a Boot Floppy menu item for m68k and powerpc
    - add section talking about debconf and note xserver powerpc settings
    - add hint for SCSI CD-ROM users (isolinux); closes: #145904
    - remove references to non-US distribution; closes: #146310
  * Karsten Merker
    - docs: fixed driverdisk filenames for mipsel, various minor
      documentation fixes/typo corrections, added documentation about
      CD-ROM boot on mipsel 
  * Antoni Bella: doc corrections
  * Ricardo Crdenes
    - Spanish translations and activation of Spanish manual versions
    - update and enable Spanish dselect guide, by Jose Carlos Garcia
  * Claus Hindsgaul
    - Danish updates
    - Chinese zh_CN.po update thanks to malix <malixren@yahoo.com>
  * Jordi Mallach
    - Catalan updates
    - Catalan manual updates from Antoni Bella
    - Catalan release-notes updates by Ivan Vilata


=== debian/control ===
Source: boot-floppies
Section: devel
Priority: extra
Maintainer: Debian Install System Team <debian-boot@lists.debian.org>
Uploaders: Adam Di Carlo <aph@debian.org>, David Kimdon <dwhedon@debian.org>
Standards-Version: 3.1.1
Build-Depends: glibc-pic, slang1-pic (>= 1.4.4-7.2) | slang1-utf8-pic (>= 1.4.4-7.2), libnewt-dev (>= 0.50.17-9.4) | libnewt-utf8-dev (>= 0.50.17-9.4), slang1-dev (>=1.4.4-7.2) | slang1-utf8-dev (>=1.4.4-7.2), libnewt-pic (>= 0.50.17-9.4) | libnewt-utf8-pic (>= 0.50.17-9.4), libpopt-dev, zlib1g-dev, recode, gettext, m4, debiandoc-sgml (>= 1.1.53), libi18n-langtags-perl, man-db, libpaperg, tetex-extra, perl5, libwww-perl, locales [i386 arm powerpc alpha], libpng2-dev [i386 arm powerpc alpha], pointerize, libgd-dev, bogl-bterm [i386 arm powerpc alpha], libbogl-dev (>= 0.1.8-1), bison, ash, dpkg-awk, flex, file, debhelper, gawk, python-dev (>= 2.1.1-4), python2.1-xml (>= 0.7-1), bf-utf-source, zlib-bin [i386 arm], dosfstools [powerpc alpha m68k], console-common [arm], vmelilo [m68k], s390-tools [s390], aboot [alpha], wget, kernel-source-2.2.20 [alpha], syslinux [i386], debootstrap, catsboot [arm], zip [arm], bzip2 [powerpc], mips-tools [mips mipsel], makedev (>= 2.3.1-58)

Package: install-doc
Section: doc
Architecture: any
Recommends: www-browser
Description: Documentation for Debian installation and release notes
 Contains documentation for the Debian installation system for this
 architecture.  Files are provided in HTML, ASCII, and PDF format in
 /usr/share/doc/install-doc.  A number of different languages are
 provided.
 .
 The full set of this this information may be found in 
   <URL:http://www.debian.org/releases/>

=== debian/rules ===
#!/usr/bin/make -f
# derived from: Sample debian.rules file - for GNU Hello (1.3).
# Copyright 1994,1995 by Ian Jackson.
# I hereby give you perpetual unlimited permission to copy,
# modify and relicense this file, provided that you do not remove
# my name from the file itself.  (I assert my moral right of
# paternity under the Copyright, Designs and Patents Act 1988.)
# This file may have to be extensively modified
#
# the debian-boot team

package	:= boot-floppies

prefix		:= debian/tmp
docdir		:= $(prefix)/usr/share/doc/$(package)

doc-package	:= install-doc
doc-prefix	:= debian/$(doc-package)
doc-docdir	:= $(doc-prefix)/usr/share/doc/$(doc-package)

install_file	:= install -o root -g root -m 644 -p
install_script	:= install -o root -g root -m 755 -p
install_program	:= install -o root -g root -m 755 -p --strip
make_dir	:= install -d -o root -g root -m 755

arch	:= $(shell dpkg --print-architecture)
version	:= $(shell LC_ALL=C dpkg-parsechangelog | sed -n 's/^Version: *//p')
dist	:= $(shell LC_ALL=C dpkg-parsechangelog | sed -n 's/^Distribution: *//p')


build:
	$(checkdir)
	$(MAKE) localfiles
	$(MAKE) check
	$(MAKE) release
	touch build

release/bf-archive-install.sh:	debian/bf-archive-install.sh
	sed 's/%arch%/$(arch)/g; s/%dist%/$(dist)/g; s/%version%/$(version)/g;' $^ > $@
	chmod a+x $@

clean:
	$(checkdir)
	-$(MAKE) -i distclean
	dh_clean
	rm -f build
	find . -name '.#*' | xargs rm -f

binary-arch:	checkroot build
	$(checkdir)

#	 build the by-hand materials for dists/<dist>/main/disks-<arch>/...
	(cd release/ ; for i in * ; do \
		cp -p $$i ../../ ; \
		dpkg-distaddfile -f../debian/files $$i byhand - ; \
	done )

#	 build the install-doc package
	rm -rf $(doc-prefix)
	$(make_dir) $(doc-docdir)
	$(MAKE) -C documentation DESTDIR=$(shell pwd)/$(doc-docdir) install
	dh_installdocs -p $(doc-package) README-CVS
	dh_installchangelogs -p $(doc-package)
	dh_compress -p $(doc-package)
	dh_fixperms -p $(doc-package)

	dh_installdeb -p $(doc-package)
	dh_gencontrol -p $(doc-package)
	dh_md5sums -p $(doc-package)
	dh_builddeb -p $(doc-package)


define checkdir
	test -f rootdisk.sh -a -f debian/rules
endef

# Below here is fairly generic really

binary:	binary-arch

checkroot:
	$(checkdir)
	test root = "`whoami`"

.PHONY: binary binary-arch binary-indep clean checkroot
